Bug 1031088 - Errai reflections jar in modules generate problems when multiple Errai webapps are installed in the same server
Errai reflections jar in modules generate problems when multiple Errai webapp...
Status: CLOSED CURRENTRELEASE
Product: JBoss BPMS Platform 6
Classification: JBoss
Component: Build and Assembly (Show other bugs)
6.0.0
Unspecified Unspecified
urgent Severity unspecified
: ER5
: 6.0.0
Assigned To: Roger Martínez
Jiri Svitak
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-15 10:21 EST by Pedro Zapata
Modified: 2015-06-01 21:35 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-08-06 16:09:16 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Pedro Zapata 2013-11-15 10:21:41 EST
FSW: We have found an issue that is blocking our use of the current module 
structure, discovered when we went to package multiple Errai based 
consoles into the same server.

The kie lib module contains the Errai reflections jar and, through that, 
we are seeing classes leak from one war context into the other.  This is 
causing ClassCastExceptions to be raised.

We are trying to find a workaround for this problem however it is 
beginning to look like we may need this to be fixed within the BRMS/BPMS 
modularisation.

Probably it would be enough to move the errai reflections jar to the webapp, and remove it from the kie lib module.
Comment 2 Roger Martínez 2013-11-15 12:10:16 EST
Two errai artifacts have been removed from org.kie.lib module:

org.jboss.errai.io.netty:netty:jar
org.jboss.errai.reflections:reflections:jar

This artifacts will be located in the webapp library as none module uses them.

Commit on 6.0.X
===============
https://github.com/droolsjbpm/kie-wb-distributions/commit/78f101e7ee563e3772d0863f1c74b92bdd75da88

Commit on master
================
https://github.com/droolsjbpm/kie-wb-distributions/commit/dc2e7c524bb7a5745f553231b36341b04b224d01
Comment 3 Roger Martínez 2013-11-15 12:18:53 EST
To be sure, I have verified the maven dependency tree for artifacts:

(1) org.jboss.errai.io.netty:netty:jar
(2) org.jboss.errai.reflections:reflections:jar

Artifact (1) is used by org.jboss.errai:errai-bus:jar, and artifact (2) is used by org.guvnor:guvnor-workingset-api:jar, both artifacts are located in the webapp classloader, so moving those errai artifacts to webapp classloader will have no impact in modules behaviour.
Comment 4 Jiri Svitak 2013-12-04 08:00:19 EST
This is rather internal productization issue, which was fixed in ER5, where EAP 6.1.1 modules are supported.

Verified in ER5.

Note You need to log in before you can comment on or make changes to this bug.